import React from 'react';
import styled from 'styled-components';
import defaultTheme from '../../theme';
import { paddable, flexbox, alignColumn, alignRow, textAlign, } from '../../utils';
export const Box = styled.div({
    display: 'flex',
    padding: '0.5em 0',
    position: 'relative',
    '&:first-of-type': {
        paddingBottom: 0,
    },
    // Last but not second
    '&:last-of-type:not(:nth-child(2))': {
        paddingTop: 0,
    },
}, (props) => ({
    flexFlow: `${props.type} wrap`,
    ...(props.type === 'column' ? alignColumn(props) : alignRow(props)),
}), textAlign, flexbox, paddable);
Box.defaultProps = {
    theme: defaultTheme,
    type: 'column',
};
export const Grid = ({ ref, type, ...props }) => (React.createElement(Box, Object.assign({}, props, { type: "row" })));
Grid.Row = ({ ref, type, ...props }) => React.createElement(Box, Object.assign({ type: "row" }, props));
Grid.Column = ({ ref, type, width, ...props }) => {
    if (width) {
        const size = typeof width === 'number' ? width : parseInt(width);
        if (size) {
            props.size = size / 16;
        }
    }
    return React.createElement(Box, Object.assign({ type: "column" }, props));
};
