import styled from 'styled-components';

import defaultTheme from '../../theme';

export interface DividerProps {
  hide?: boolean;
  vertical?: boolean;
}

export const Divider = styled.div<DividerProps>(
  {
    margin: '1rem 0',
    lineHeight: '1em',
    height: 0,
  },
  ({ theme, hide, vertical }) =>
    vertical
      ? {
          borderLeft: `1px solid ${
            hide ? 'transparent' : theme.greyscale.medium
          }`,
          borderRight: '1px solid hsla(0,0%,100%,.1)',
          height: '100%',
          left: '50%',
          position: 'absolute',
          transform: 'translateX(-50%)',
          width: 'auto',
          margin: '0 1rem',
        }
      : {
          borderTop: `1px solid ${
            hide ? 'transparent' : theme.greyscale.medium
          }`,
          borderBottom: '1px solid hsla(0,0%,100%,.1)',
        },
);

Divider.defaultProps = {
  theme: defaultTheme,
};
