import { CSSObject, DefaultTheme } from 'styled-components';

import { HiroColors } from '../types';

export const text = <T extends { color?: HiroColors; theme: DefaultTheme }>({
  color,
  theme,
}: T): CSSObject | null =>
  color
    ? {
        color: theme.colors[color].default,
      }
    : null;

export const primary = <T extends { color?: HiroColors; theme: DefaultTheme }>({
  color,
  theme,
}: T): CSSObject => {
  return {
    color: 'white',
    border: 'none',
    backgroundColor: theme.colors[color || 'primary'].default,
  };
};

export const secondary = <
  T extends { color?: HiroColors; theme: DefaultTheme }
>({
  theme,
  color,
}: T): CSSObject => {
  const colour = theme.colors[color || 'primary'];

  return {
    border: `1px solid ${colour.light}`,
    backgroundColor: 'transparent',
    color: colour.default,
  };
};
